/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package lib;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

/**
 *
 * @author _yy
 */
public class Graph {

    private ArrayList<Node> nodes = new ArrayList<Node>();
    private ArrayList<Edge> edges = new ArrayList<Edge>();

    public Graph(String name) {
        this.addNode(new Node(name));
    }

    public Graph() {
    }

    public Graph(String[] args) {
        System.out.println(args);
    }

    //add a single Node into the graph
    public void addNode(Node e) {
        boolean ne1 = false;
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node n = (Node) it.next();
            if (n.getName().equals(e.getName())) {
//                System.out.println("The Node: " + e.getName() + " is already existed in the Graph.");
                ne1 = true;
                break;
            }
        }
        if (ne1 == false) {
            nodes.add(e);
        }
    }

    public void addNode(String s) {
        boolean ne1 = false;
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node n = (Node) it.next();
            if (n.getName().equals(s)) {
                ne1 = true;
                break;
            }
        }
        if (ne1 == false) {
            nodes.add(new Node(s));
        }
    }

    public void visitAll() {
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node n = (Node) it.next();
            n.visit();
        }
    }

    public void unvisitAll() {
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node n = (Node) it.next();
            n.unvisit();
        }
    }

    public void addEdge(String n1, String n2, double weight) {
        addNode(n1);
        addNode(n2);
        //add new edge
        Edge e = new Edge(n1, n2, weight);
        edges.add(e);
    }

    public void addBEdge(String n1, String n2, double weight) {
        //add new edge
        addNode(n1);
        addNode(n2);
        Edge e = new Edge(n1, n2, weight);
        Edge e1 = new Edge(n2, n1, weight);
        edges.add(e);
        edges.add(e1);
    }

    public Node getNode(String e) {
        //check if the Node is in the graph
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node n = (Node) it.next();
            if (e.equals(n.getName())) {
                return n;
            }
        }
        return null;
    }

    public ArrayList<Node> removeDups(ArrayList<Node> l)
    {
        HashSet<Node> temp = new HashSet<Node>();
        temp.addAll(l);
        l.clear();
        l.addAll(temp);
        return l;
    }

    public ArrayList<Node> getNodesFromWith(String name, ArrayList<Node> path, String qualifier, String predicate) {
        return removeDups(getNodesFromWith(getNode(name), path, qualifier, predicate));
    }

    public ArrayList<Node> getNodesFromWith(Node e, ArrayList<Node> path, String qualifier, String predicate) {

        boolean visited = false;
        if (path == null) {
            path = new ArrayList<Node>();
        }
        if (qualifier.toLowerCase().equals("unvisited")) {
            visited = false;
        } else if (qualifier.toLowerCase().equals("visited")) {
            visited = true;
        } else {
            System.err.println("qualifier error.");
        }
        Iterator it = edges.iterator();
        if (predicate == null) {
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName())
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
            return path;
        } else if (predicate.contains("==")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName()) && ed.getEdgeweight() == inum
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
        } else if (predicate.contains("!=")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName()) && ed.getEdgeweight() != inum
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
        } else if (predicate.contains("<=")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName()) && ed.getEdgeweight() <= inum
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
        } else if (predicate.contains(">=")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName()) && ed.getEdgeweight() >= inum
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
        } else if (predicate.contains("<")) {
            String num = predicate.substring(1);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName()) && ed.getEdgeweight() < inum
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
        } else if (predicate.contains(">")) {
            String num = predicate.substring(1);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getStartNode().equals(e.getName()) && ed.getEdgeweight() > inum
                        && getNode(ed.getEndNode()).isVisit() == visited) {
                    path.add(getNode(ed.getEndNode()));
                }
            }
        }
        return path;
    }

    public ArrayList<Node> getNodesToWith(String name, ArrayList<Node> path, String qualifier, String predicate) {
        return removeDups(getNodesToWith(getNode(name), path, qualifier, predicate));
    }

    public ArrayList<Node> getNodesToWith(Node e, ArrayList<Node> path, String qualifier, String predicate, double weight) {
        if (predicate.equals("")) {
            return getNodesToWith(e, path, qualifier, null);
        } else {
            return getNodesToWith(e, path, qualifier, predicate + weight);
        }
    }

    public ArrayList<Node> getNodesFromWith(Node e, ArrayList<Node> path, String qualifier, String predicate, double weight) {
        if (predicate.equals("")) {
            return getNodesFromWith(e, path, qualifier, null);
        } else {
            return getNodesFromWith(e, path, qualifier, predicate + weight);
        }
    }

    public ArrayList<Node> getNodesToWith(Node e, ArrayList<Node> path, String qualifier, String predicate) {
        boolean visited = false;
        Iterator it = edges.iterator();

        if (path == null) {
            path = new ArrayList<Node>();
        }
        if (qualifier.toLowerCase().equals("unvisited")) {
            visited = false;
        } else if (qualifier.toLowerCase().equals("visited")) {
            visited = true;
        } else {
            System.err.println("qualifier error.");
        }

        if (predicate == null) {
            while (it.hasNext()) {

                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName())
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
            return path;
        } else if (predicate.contains("==")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName()) && ed.getEdgeweight() == inum
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
        } else if (predicate.contains("<=")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName()) && ed.getEdgeweight() <= inum
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
        } else if (predicate.contains(">=")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName()) && ed.getEdgeweight() >= inum
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
        } else if (predicate.contains("!=")) {
            String num = predicate.substring(2);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName()) && ed.getEdgeweight() != inum
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
        } else if (predicate.contains("<")) {
            String num = predicate.substring(1);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName()) && ed.getEdgeweight() < inum
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
        } else if (predicate.contains(">")) {
            String num = predicate.substring(1);
            double inum = Double.parseDouble(num);
            while (it.hasNext()) {
                Edge ed = (Edge) it.next();
                if (ed.getEndNode().equals(e.getName()) && ed.getEdgeweight() > inum
                        && getNode(ed.getStartNode()).isVisit() == visited) {
                    path.add(getNode(ed.getStartNode()));
                }
            }
        }
        return path;
    }

    public int numNodes() {
        return nodes.size();
    }

    public int numEdges() {
        return edges.size();
    }

    public void infoGraph() {
        System.out.print("Graph: ");
        System.out.println("node: " + numNodes() + ", edge " + numEdges() + ".");
    }

    public void nameNodes() {
        Iterator it = nodes.iterator();
        System.out.println("This graph contains following Nodes:");
        while (it.hasNext()) {
            Node n = (Node) it.next();
            System.out.println(n.getName() + " ");
        }
    }

    public boolean Siblings(Node e) {
        boolean e1 = false;
        boolean e2 = false;
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Node n = (Node) it.next();
            if (e.getName().equals(n.getName())) {
                e1 = true;
            }
        }
        if (e1 == false) {
            System.out.println("Node " + e.getName() + " is not found in the graph.");
        } else {
            Iterator it2 = edges.iterator();
            while (it2.hasNext()) {
                Edge ed = (Edge) it2.next();
                if (ed.getStartNode().equals(e.getName())) {
                    e2 = true;
                    System.out.println("Node: " + e.getName() + " connected to Node " + ed.getEndNode() + " with weight " + ed.getEdgeweight());
                }
            }
        }
        if (e2 == false) {
            System.out.println("Node: " + e.getName() + " does not connect to any other node.");
            return false;
        } else if (e2 == true) {
            return true;
        }
        return false;
    }
//    public void add(Node n1, Node n2, String ed) {
//        String sub = ed.substring(0, 2);
//        double weight = Double.parseDouble(ed.substring(2));
////        int weight = Integer.parseInt(ed.substring(2));
//        if (sub.equals("<>")) {
//            addBEdge(n1, n2, weight);
//        } else if (sub.equals("<<")) {
//            addEdge(n1, n2, weight);
//        } else if (sub.equals(">>")) {
//            addEdge(n2, n1, weight);
//        } else {
//            System.out.println("Error initialize the graph");
//        }
//    }
}
